# -*- coding: utf-8 -*-
"""
Created on Wed Jul 29 12:16:34 2020

@author: yiwzh
"""

import pandas as pd
from datetime import datetime, timedelta
import os
import matplotlib.pyplot as plt
import matplotlib.dates as dates
import numpy as np
#%%
output_folder = "D:\\PeregrinePaper0903\\stageCostModel\\img"
data = pd.read_csv("D:\\data\\cosmos15\\summary_vertex_month_2018-09-01_2020-07-27.csv", sep="\t")
data = pd.read_csv("D:\\data\\cosmos15\\summary_vertex_month_2018-08-01_2020-08-07.csv", sep="\t")
data = pd.read_csv("D:\\data\\cosmos15\\summary_vertex_month_2018-08-01_2020-08-27.csv", sep="\t")

data["Month"] =  data["Month"].apply(
        lambda x: datetime.strptime(x.split(".")[0], '%m/%d/%Y %H:%M:%S %p'))

data = data.set_index("Month")
data = data.sort_index()

data = data.drop([data.index[107]])
data = data.head(600)
data["Ratio"] = data["avgSumTempDataWritten"]/data["avgSumTotalDataRead"]

var1 = "vertexCount"
var = "avgSumTotalDataRead"
data = data.drop(data[data[var]==52279776156164.87].index)

fig, ax1 = plt.subplots(figsize=(5,3))
color = "tab:orange"
ax1.set_ylabel("TotalDataRead (Bytes)", color=color)
ax1.plot(data[var], label = "TotalDataRead", linestyle = "dashed",color = "tab:orange")
#ax1.plot(summary_control[variable1], label = "control")
#ax1.plot(summary_control2[variable1], label = "control_{}".format(variable1),linestyle = ":",color = "tab:blue")
ax1.set_ylim(0,np.percentile(data[var],50) * 2)
#ax1.plot(summary_exp["avg_value_CT14"], label = "exp_G_token",color = "tab:orange",linestyle = ":")
##ax1.plot(summary_control[variable1], label = "control")
#ax1.plot(summary_control2["avg_value_CT14"], label = "control_selected_G_token",color = "tab:blue",linestyle = ":")
ax1.tick_params(axis='x', rotation=45)

ax1.tick_params(axis='y', labelcolor=color)
#ax1.axvline(datetime.strptime("2020-07-10 16:00", '%Y-%m-%d %H:%M'), color = 'red',linestyle = ":")
ax1.legend(loc="upper left")

ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
ax2.set_ylabel("VertexCount", color="tab:blue")
ax2.xaxis.set_major_formatter(dates.DateFormatter('%Y-%m'))
#ax2.set_ylim(0,np.percentile(data.avg_jobRuntime,50) * 2.5)
ax2.tick_params(axis='y', labelcolor="tab:blue")

color = 'tab:blue'
ax2.plot(data["vertexCount"], label = "VertexCount",color = "tab:blue",alpha=0.7)
#    ax1.plot(summary_control[variable1], label = "control")
ax2.legend(loc="lower right")
#    
plt.tight_layout() 
plt.savefig(os.path.join(output_folder, "trend3.pdf"))  
#%%
plt.plot(data["avg_jobRuntime"]/60)
plt.ylim(0,60)
#%%
def make_patch_spines_invisible(ax):
    ax.set_frame_on(True)
    ax.patch.set_visible(False)
    for sp in ax.spines.values():
        sp.set_visible(False)


fig, host = plt.subplots(figsize=(6,3.5))
fig.subplots_adjust(right=0.75)

par1 = host.twinx()
par2 = host.twinx()

# Offset the right spine of par2.  The ticks and label have already been
# placed on the right by twinx above.
par2.spines["right"].set_position(("axes", 1.2))
# Having been created by twinx, par2 has its frame off, so the line of its
# detached spine is invisible.  First, activate the frame but make the patch
# and spines invisible.
make_patch_spines_invisible(par2)
# Second, show the right spine.
par2.spines["right"].set_visible(True)

p1, = host.plot(data["avgSumTempDataWritten"], label = "TempDataWritten",color = "tab:blue",alpha=0.7)
p2, = par1.plot(data[var], label = "TotalDataRead", linestyle = "dashed",color = "tab:orange")
p3, = par2.plot(data[var1], label = "VertexCount", linestyle = "dashed",color = "tab:green")

#host.set_xlim(0, 2)
host.set_ylim(2e12,np.percentile(data.avgSumTempDataWritten,50) * 2.5)
par1.set_ylim(4e12,np.percentile(data[var],50) * 2)
par2.set_ylim(0,np.percentile(data[var1],50) * 1.5)

#host.set_xlabel("Distance")
host.set_ylabel("TempDataWritten (Bytes)")
par1.set_ylabel("TotalDataRead (Bytes)")
par2.set_ylabel("VertexCount")

host.yaxis.label.set_color(p1.get_color())
par1.yaxis.label.set_color(p2.get_color())
par2.yaxis.label.set_color(p3.get_color())

tkw = dict(size=4, width=1.5)
host.tick_params(axis='y', colors=p1.get_color(), **tkw)
par1.tick_params(axis='y', colors=p2.get_color(), **tkw)
par2.tick_params(axis='y', colors=p3.get_color(), **tkw)
host.tick_params(axis='x', rotation=45)
host.xaxis.set_major_formatter(dates.DateFormatter('%Y-%m'))

lines = [p1, p2, p3]

host.legend(lines, [l.get_label() for l in lines],loc="upper left")
plt.tight_layout() 
plt.savefig(os.path.join(output_folder, "trend2.pdf"))  
#%%
ssd = pd.read_csv(r'C:\Users\yiwzh\Downloads\nMBSsdFree_VitalSigns.csv')
machineinfo = pd.read_csv(r"D:\\data\\cosmos08\\machineinfo.csv")
plt.figure(figsize=(5,3))
ssd = ssd.set_index("MachineName").join(machineinfo.set_index("MachineName"))
for sku in pd.factorize(ssd.SKU)[1]:
    data_sub = ssd[ssd["SKU"]==sku]
    plt.hist(data_sub.Value/1e3,bins = np.linspace(0,2e3,200), density=True, histtype='step',
                               cumulative=True)
plt.xlabel("SSD Available Space (GB) for Different SKUs")
plt.ylabel("ECDF")
plt.tight_layout()
plt.savefig(os.path.join(output_folder, "trend5.pdf"))  

plt.figure(figsize=(5,3))
plt.hist(ssd.Value/1e3,bins = np.linspace(0,2e3,200), density=True, histtype='step',
                               cumulative=True)
plt.xlabel("SSD Available Space (GB)")
plt.ylabel("ECDF")
plt.tight_layout()
plt.savefig(os.path.join(output_folder, "trend4.pdf"))  

#%%
fail = pd.read_csv("D:\\data\\cosmos15\\summary_failure_day_2020-09-17_2020-09-18.csv",sep="\t")
fail["FailureType"].value_counts()/len(fail)

job_fail = pd.read_csv(r'D:\data\cosmos15\summary_failure_day_job_2020-09-10_2020-09-18.csv',sep="\t")
job_fail["Group"] = (job_fail["JobRunTime"]/60/20).astype(int) * 10

fnrd = lambda obj: len(obj[obj["JobExitStatus"]!="CompletedSuccess"])/len(obj)

fail_summary = job_fail.groupby("Group", as_index=False).apply(fnrd).reset_index()

#plt.hist(job_fail["JobRunTime"]/60,bins=np.linspace(0,80,9))
#plt.plot(fail_summary["index"],fail_summary[0])
#%%
max_lim = 240
bins = 20
job_fail["Group"] = (job_fail["JobRunTime"]/60/bins).astype(int) * bins

fnrd = lambda obj: len(obj[obj["JobExitStatus"]!="CompletedSuccess"])/len(obj)

fail_summary = job_fail.groupby("Group", as_index=False).apply(fnrd).reset_index()
fail_summary["index"] = fail_summary["index"] * bins
fail_summary = fail_summary[fail_summary["index"]<=max_lim]

fig, ax1 = plt.subplots(figsize=(5,3))
color = "tab:orange"
ax1.set_ylabel("PDF", color=color)
ax1.set_xlabel("Job Runtime (min)")

ax1.hist(job_fail["JobRunTime"]/60,bins=np.linspace(0,max_lim,int(max_lim/10 + 1)), density=True,label="PDF",color="tab:orange")
#ax1.plot(summary_control[variable1], label = "control")
#ax1.plot(summary_control2[variable1], label = "control_{}".format(variable1),linestyle = ":",color = "tab:blue")
#ax1.set_ylim(0,np.percentile(data[var],50) * 2)
#ax1.plot(summary_exp["avg_value_CT14"], label = "exp_G_token",color = "tab:orange",linestyle = ":")
##ax1.plot(summary_control[variable1], label = "control")
#ax1.plot(summary_control2["avg_value_CT14"], label = "control_selected_G_token",color = "tab:blue",linestyle = ":")
ax1.tick_params(axis='x', rotation=0)

ax1.tick_params(axis='y', labelcolor=color)
#ax1.axvline(datetime.strptime("2020-07-10 16:00", '%Y-%m-%d %H:%M'), color = 'red',linestyle = ":")
ax1.legend(loc="upper left")

ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
ax2.set_ylabel("Failure Rate", color="tab:blue")
#ax2.set_ylim(0,np.percentile(data.avg_jobRuntime,50) * 2.5)

color = 'tab:blue'
ax2.plot(fail_summary["index"],fail_summary[0],color="tab:blue",label="Failure Rate")
ax2.tick_params(axis='y', labelcolor="tab:blue")

#    ax1.plot(summary_control[variable1], label = "control")
ax2.legend(loc="upper right")
#    
plt.tight_layout() 
plt.savefig(os.path.join(output_folder, "failure.pdf"))  

#%%
plt.figure(figsize=(3,2.5))
i = 1
bins_ = np.linspace(2,5e5,1000000)
for cluster in ["cosmos09","cosmos08","cosmos11","cosmos14","cosmos15"]:
    df = pd.read_csv("D:\\data\\{}\\summary_vertex_count_2020-09-18_2020-09-21.csv".format(cluster),sep="\t")
    plt.hist(df["vertexCount"], label = "cluster" + str(i),bins = bins_, density=True, histtype='step', cumulative=True)
    i += 1
plt.legend(loc="lower right")
plt.xscale("log")
plt.xlabel("Number of Vertex per Job")
plt.ylabel("ECDF")
plt.tight_layout() 
plt.savefig("D:\kea-papers\KEA_VLDB\imgs\concepts\count.pdf")  


#%%
plt.figure(figsize=(3,2.5))
i = 1
df_all = []
bins_ = np.linspace(2,5e6,10000000)
for cluster in ["cosmos09","cosmos08","cosmos11","cosmos14","cosmos15"]:
    df = pd.read_csv("D:\\data\\{}\\summary_vertex_count_2020-09-18_2020-09-21.csv".format(cluster),sep="\t")
    df_all.append(df)
    plt.hist(df["SumTotalDataRead"]/1e9, label = "cluster" + str(i),bins = bins_, density=True, histtype='step', cumulative=True)
    i += 1
plt.legend(loc="lower right")
plt.xscale("log")
plt.xlabel("Data Read per Job (GB)")
plt.ylabel("ECDF")
plt.tight_layout() 
plt.savefig("D:\kea-papers\KEA_VLDB\imgs\concepts\data.pdf")  
#%%
df_all = pd.concat(df_all)
df_all.groupby("Month").sum()
#%%

token = pd.read_csv("D:\\data\\cosmos14\\vc_low_priority_2020-08-21_2020-09-23.new_increased_all.csv",sep="\t")
token["time"] =  token["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + token["Hour"].apply(lambda x: timedelta(hours=x))
token = token.set_index("time").sort_index()

#%%
fig, ax1 = plt.subplots(figsize=(12,3))

ax1.plot(token["avg_h"], label="Guaranteed Tokens")
ax1.plot(token["avg_h"] + token["avg_l"], label="All")
ax1.set_ylim(0,600000)
ax1.set_ylabel("Total Tokens")
plt.axvline(x=datetime.strptime("8/24/2020 00:00:01 AM", '%m/%d/%Y %H:%M:%S %p'), linewidth=1, color='r', linestyle=":")
plt.axvline(x=datetime.strptime("8/31/2020 00:00:01 AM", '%m/%d/%Y %H:%M:%S %p'), linewidth=1, color='r', linestyle=":")
plt.axvline(x=datetime.strptime("9/7/2020 00:00:01 AM", '%m/%d/%Y %H:%M:%S %p'), linewidth=1, color='r', linestyle=":")
plt.axvline(x=datetime.strptime("9/14/2020 00:00:01 AM", '%m/%d/%Y %H:%M:%S %p'), linewidth=1, color='r', linestyle=":")
plt.axvline(x=datetime.strptime("9/21/2020 00:00:01 AM", '%m/%d/%Y %H:%M:%S %p'), linewidth=1, color='r', linestyle=":")
ax1.legend()
ax1.tick_params(axis='x', rotation=45)

#%%
import pandas as pd
import os
df14 = pd.read_csv("D:\\data\\cosmos08\\cosmos08_data_raw_joined_week_h_sample.csv")
output_folder = "D:\kea-papers\KEA_VLDB\imgs\concepts"

sku_map = {'E3_WCS-Wiwynn17-i20b':"V17-2", 'E2_Dell14-i20b':"V14-1", 'E3_WCS-Wiwynn15-i22b{6TB}':"V15-1",
        'E3_WCS-Dell17-i20b':"V17-1", 'E3_WCS-Quanta15-i22b{6TB}':"V15-2"}
plt.figure(figsize=(3,2.5))
for mf_sku in pd.factorize(df14.mf_sku)[1]:
    data_sub = df14[df14["mf_sku"]==mf_sku]
    plt.hist(data_sub.avg_executiontime,bins = np.linspace(0,100,200), density=True, histtype='step',
                               cumulative=True,label=sku_map[mf_sku])
plt.xlabel("Average Vertex Execution Time (s)")
plt.ylabel("ECDF")
plt.legend(loc="lower right")
plt.tight_layout()
plt.savefig(os.path.join(output_folder, "vt.pdf"))  
#%%
import numpy as np
sku_d = pd.read_csv("D:\\data\\cosmos08\\countingSKUsOutput2020-08-01...2020-08-07.csv",header=None)
sku_d["all"] = sku_d[1] / np.sum(sku_d[1])

sku_d2 = pd.read_csv("D:\\data\\cosmos08\\countingCriticalSKUsOutput2020-08-01...2020-08-07.csv",header=None)
sku_d2["all"] = sku_d2[1] / np.sum(sku_d2[1])
sku_d2 = sku_d2.set_index(0).join(sku_d.set_index(0),rsuffix="_r").reset_index()

sku_map = {'WCS-Wiwynn17-i20b':"V17-2", 'Dell14-i20b':"V14-1", 'WCS-Wiwynn15-i22b{6TB}':"V15-1",
        'WCS-Dell17-i20b':"V17-1", 'WCS-Quanta15-i22b{6TB}':"V15-2"}

sku_d2["mf_sku"] = sku_d2[0].apply(lambda x: sku_map[x]) 
sku_d2["pct"] = sku_d2["1"]/sku_d2["1_r"]*100

plt.figure(figsize=(4.0,3.6))
sku_d2.set_index("mf_sku")["pct"].plot.bar()
plt.xlabel("SKU")
plt.ylabel("Percentage of Critical Vertex (%)")
plt.tight_layout()
plt.savefig(os.path.join(output_folder, "critical.pdf"))  


df14 = pd.read_csv("D:\\data\\cosmos08\\data_raw_joined_h_2019-12-14.csv")
df14[["mf_sku","CPU_Utilization"]].groupby("mf_sku").mean()


#%%
from util import plot_scatter_hist,stacked_bar

            
#===========================================vertex data summary

vertex_summary_file = "D:\data\cosmos09\summary_vertex_stats_by_machine_stage_2019-05-19_2019-05-25.csv"
ap_summary_file = "cosmos09/cosmos09_summary_counters_2018-10-09_2018-10-10.ss.csv"
cluster_name = "cosmos09"
machine_list_file = "D:\data\cosmos09\machineinfo_0730.csv"


data2 = pd.read_csv(vertex_summary_file) #vertex ended data processed, machine summary
#data2['Date'] = data2['Date'].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p'))
#data2['Date_nbr'] = data2['Date'].apply(lambda x: x.day)
#
data3 = pd.read_csv(machine_list_file)
data3["MachineName"] = data3["MachineName"].str.lower()
data_joined = data2.set_index('MachineName').join(data3.set_index('MachineName'))
data_joined_e2e3 = data_joined.ix[(data_joined["MachineFunction"] =="E2") | (data_joined["MachineFunction"] =="E3")]
SKU_list = list(pd.factorize(data_joined_e2e3["SKU"])[1])

core_list = pd.DataFrame({
        "SKU":['WCS-Dell15-i22b', 
               'WCS-HP15-i22b', 
               'HP14-i28b', 
               'WCS-HP15-i22b{6TB}',
               'WCS-Dell16-i22b',
               'WCS-Dell17-i20b',
               'WCS-Wiwynn17-i20b',
               'Dell13-i28b',
               'Dell14-i20b',
               'WCS-Quanta15-i22b{6TB}',
               'WCS-Wiwynn15-i22b{6TB}'],
        "NbrCores":[24,24,16,24,24,40,40,16,20,24,24]})

data_joined_e2e3 = data_joined_e2e3.reset_index()
data_joined_e2e3_core = data_joined_e2e3.set_index('SKU').join(core_list.set_index('SKU'))
data_joined_e2e3_core = data_joined_e2e3_core.reset_index()

data_joined_e2e3["Rack"] = data_joined_e2e3["PodName"].apply(lambda x: int(x[9:12]))
data_joined_e2e3["SKU"] = data_joined_e2e3["SKU"].apply(lambda x: sku_map[x])
#get job count by cell
PodName = list(pd.factorize(data_joined_e2e3["Rack"])[1])[0]
data_joined_e2_sub_sku = data_joined_e2e3.loc[data_joined_e2e3["Rack"] == PodName]
job_count = data_joined_e2_sub_sku[["DryadStageName2","totRows"]].groupby("DryadStageName2").sum()
job_count = job_count.drop("totRows",axis='columns')

for PodName in list(pd.factorize(data_joined_e2e3["Rack"])[1]):
#    plt.figure()
    data_joined_e2_sub_sku = data_joined_e2e3.loc[data_joined_e2e3["Rack"] == PodName]
    tmp_counts = data_joined_e2_sub_sku[["DryadStageName2","totRows"]].groupby("DryadStageName2").sum()["totRows"]

    job_count = pd.concat([tmp_counts,job_count],axis = 1)
    job_count[str(PodName)] = job_count["totRows"]/np.sum(job_count["totRows"])
    
    job_count = job_count.drop("totRows",axis='columns')

#get job count by SKU
SKU = list(pd.factorize(data_joined_e2e3["SKU"])[1])[0]
data_joined_e2_sub_sku = data_joined_e2e3.loc[data_joined_e2e3["SKU"] == SKU]
#job_count2 = data_joined_e2_sub_sku[["DryadStageName2"]].apply(pd.value_counts)
job_count2 = data_joined_e2_sub_sku[["DryadStageName2","totRows"]].groupby("DryadStageName2").sum()
job_count2 = job_count2.drop("totRows",axis='columns')

for SKU in list(pd.factorize(data_joined_e2e3["SKU"])[1]):
#    plt.figure()
    data_joined_e2_sub_sku = data_joined_e2e3.loc[data_joined_e2e3["SKU"] == SKU]
#    tmp_counts = data_joined_e2_sub_sku[["DryadStageName2"]].apply(pd.value_counts)
#    job_count2[str(SKU)] = tmp_counts/len(data_joined_e2_sub_sku)
#job_count2 = job_count2.drop("DryadStageName2",axis='columns')
    tmp_counts = data_joined_e2_sub_sku[["DryadStageName2","totRows"]].groupby("DryadStageName2").sum()["totRows"]

    job_count2 = pd.concat([tmp_counts,job_count2],axis = 1)
    job_count2[str(SKU)] = job_count2["totRows"]/np.sum(job_count2["totRows"])
    
    job_count2 = job_count2.drop("totRows",axis='columns')

##get job count by MachineFunc
#machineFunc = ["E2","E3"][0]
#data_joined_e2_sub_mf = data_joined_e2e3.loc[data_joined_e2e3["MachineFunction"] == machineFunc]
#job_count3 = data_joined_e2_sub_mf[["DryadStageName2"]].apply(pd.value_counts)
#
#for machineFunc in ["E2","E3"]:
##    plt.figure()
#    data_joined_e2_sub_mf = data_joined_e2e3.loc[data_joined_e2e3["MachineFunction"] == machineFunc]
#    tmp_counts = data_joined_e2_sub_mf[["DryadStageName2"]].apply(pd.value_counts)
#    job_count3[machineFunc] = tmp_counts/len(data_joined_e2_sub_mf)
#job_count3 = job_count3.drop("DryadStageName2",axis='columns')
#%%
output_folder = r"D:\kea-papers\KEA_VLDB\imgs\concepts"
#job type count figures
plt.figure(figsize=(4,3))
series_labels = list(job_count.index)
category_labels = list(job_count.columns)
stacked_bar(
    np.array(job_count), 
    series_labels, 
    category_labels=category_labels, 
    show_values=True, 
    value_format="{:.3f}",
    y_label="Quantity (percentage)",
    x_label="PodName"
)
plt.rc('axes', labelsize=14)    # fontsize of the x and y labels
plt.tight_layout()
plt.savefig(os.path.join(output_folder,"cosmos11_job_type_count.pdf"))
plt.show()

plt.figure(figsize=(4,3))
series_labels = list(job_count2.index)
category_labels = list(job_count2.columns)
stacked_bar(
    np.array(job_count2), 
    series_labels, 
    category_labels=category_labels, 
    show_values=True, 
    value_format="{:.3f}",
    y_label="Quantity (percentage)",
    x_label="SKU",
    rotation = 30
)
plt.rc('axes', labelsize=14)    # fontsize of the x and y labels
plt.tight_layout()
plt.savefig(os.path.join(output_folder,"cosmos11_job_type_count2.pdf"))
plt.show()

#%%
sku_map = {'E3_WCS-Wiwynn17-i20b':"V17-2", 'E2_Dell14-i20b':"V14-1", 'E3_WCS-Wiwynn15-i22b{6TB}':"V15-1",
        'E3_WCS-Dell17-i20b':"V17-1", 'E3_WCS-Quanta15-i22b{6TB}':"V15-2"}

#vertex_size = pd.read_csv("D:\\data\\cosmos11\\cosmos11_data_raw_joined_week_h_sample.csv")
vertex_size = pd.read_csv("D:\\data\\cosmos11\\data_raw_joined_h_2020-07-28.csv")
vertex_size["vertex_size"] = vertex_size["sumTotalDataRead"]/vertex_size["totRows"]
#%%
plt.figure(figsize=(4,3))

for mf_sku in pd.factorize(vertex_size.SKU)[1]:
    data_sub = vertex_size[vertex_size["SKU"]==mf_sku]
    data_sub = data_sub[data_sub["totRows"]>700]
    plt.hist(data_sub.vertex_size,bins = np.linspace(0,8e9,200), density=True, histtype='step',
                               cumulative=True,label=mf_sku)
plt.xlabel("Average Vertex Size")
plt.ylabel("ECDF")
#plt.legend(loc="lower right")
plt.tight_layout()
plt.savefig(os.path.join(output_folder,"ecdf.pdf"))

#%%
plt.figure(figsize=(4,3))
#vertex_size = pd.read_csv("D:\\data\\cosmos11\\cosmos11_data_raw_joined_week.csv")

for mf_sku in pd.factorize(vertex_size.SKU)[1]:
#for mf_sku in pd.factorize(vertex_size.SKU)[1][:3]:

    data_sub = vertex_size[vertex_size["SKU"]==mf_sku]
    plt.scatter(data_sub.totRows,data_sub.sumTotalDataRead,s=0.1,alpha=0.1,label=mf_sku)
plt.xlabel("Number of Vertex")
plt.ylabel("Total Data Read")
#plt.legend(loc="lower right")
plt.tight_layout()
plt.savefig(os.path.join(output_folder,"vertex_size_scatter.pdf"))

#%%
vertex_raw = pd.read_csv("D:\\data\\cosmos09\\vertex_ended_raw_2019-02-01_2019-02-02.csv",sep="\t")
machineinfo = pd.read_csv("D:\\data\\cosmos09\\machineinfo_0730.csv")
machineinfo["MachineName"]=machineinfo["MachineName"].str.lower()
vertex_raw=vertex_raw.set_index("MachineName").join(machineinfo.set_index("MachineName"))
vertex_raw_drop = vertex_raw.dropna(subset=["PodName"])
#%%

plt.figure(figsize=(4,3))
for sku in pd.factorize(vertex_raw_drop["SKU"])[1]:
    data_sub=vertex_raw_drop[vertex_raw_drop["SKU"]==sku]
    plt.hist(data_sub["TotalDataRead"],bins=np.linspace(0,4e9,1001),density=True,histtype="step",
             cumulative=True,label=sku_map[sku])
#plt.xscale("log")
plt.legend(loc="lower right")
plt.xlabel("Vertex Size")
plt.ylabel("ECDF")
plt.tight_layout()
plt.savefig(os.path.join(output_folder,"ecdf_raw.pdf"))

#%%
revo = pd.read_csv("D:\\data\\cosmos09\\JobData_2020-09-15_2020-10-04.csv",sep="\t")

#%%
for cluster in ["cosmos08","cosmos09","cosmos14","cosmos15"]:
    df = pd.read_csv(r"d:/data/%s/tp_vc_low_priority_2020-10-01_2020-10-29.new_increased.csv" %cluster,sep="\t")
    df["time"] =  df["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df["Hour"].apply(lambda x: timedelta(hours=x))
    df=df[df["time"]>datetime.strptime('10/01/2020 12:00:00', '%m/%d/%Y %H:%M:%S')]
    df = df.set_index("time")
    df = df.sort_index()
    plt.plot(df["max_TempDataRTP"]*1e6,label=cluster)
    plt.ylabel("Temp data Read (GB/s)")
    locs, labels = plt.xticks()
    plt.title("MAX")
    plt.ylim(0,15000)
    plt.setp(labels, rotation=45)
    plt.legend()
#%%
#for cluster in ["cosmos08","cosmos09","cosmos11","cosmos14","cosmos15"]:
for cluster in ["cosmos14"]:
    df = pd.read_csv(r"d:/data/%s/tp_vc_low_priority_2020-10-01_2020-10-29.new_increased.csv" %cluster,sep="\t")
    df["time"] =  df["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df["Hour"].apply(lambda x: timedelta(hours=x))
    df=df[df["time"]>datetime.strptime('10/01/2020 12:00:00', '%m/%d/%Y %H:%M:%S')]
    df = df.set_index("time")
    df = df.sort_index()    
    plt.plot(df["max_TempDataWTP"]*1e6,label=cluster)
    plt.ylabel("Temp data Written (GB/s)")
    locs, labels = plt.xticks()
    plt.title("MAX")
    plt.ylim(0,15000)

    plt.setp(labels, rotation=45)
    plt.legend()
#%%
for cluster in ["cosmos08","cosmos09","cosmos14","cosmos15"]:
    df = pd.read_csv(r"d:/data/%s/tp_vc_low_priority_2020-10-01_2020-10-29.new_increased.csv" %cluster,sep="\t")
    df["time"] =  df["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df["Hour"].apply(lambda x: timedelta(hours=x))
    df=df[df["time"]>datetime.strptime('10/01/2020 12:00:00', '%m/%d/%Y %H:%M:%S')]
    df = df.set_index("time")
    df = df.sort_index()
    plt.plot(df["avg_avg_TempDataWTP"]*1e6,label=cluster)
    plt.ylabel("Temp data Read (GB/s)")
    locs, labels = plt.xticks()
    plt.title("AVG")
    plt.setp(labels, rotation=45)
    plt.legend()
#%%
for cluster in ["cosmos08","cosmos09","cosmos14","cosmos15"]:
    df = pd.read_csv(r"d:/data/%s/tp_vc_low_priority_2020-10-01_2020-10-29.new_increased.csv" %cluster,sep="\t")
    df["time"] =  df["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df["Hour"].apply(lambda x: timedelta(hours=x))
    df=df[df["time"]>datetime.strptime('10/01/2020 12:00:00', '%m/%d/%Y %H:%M:%S')]
    df = df.set_index("time")
    df = df.sort_index()    
    plt.plot(df["avg_avg_TempDataWTP"]*1e6,label=cluster)
    plt.ylabel("Temp data Written (GB/s)")
    locs, labels = plt.xticks()
    plt.title("AVG")
    plt.setp(labels, rotation=45)
    plt.legend()

#%%
df = pd.read_csv(r"d:/data/cosmos14/vc_low_priority_2020-10-21_2020-10-25.new_increased.csv",sep="\t" )
df2 = pd.read_csv(r"d:/data/cosmos14/vc_low_priority_2020-10-01_2020-10-05.new_increased.csv",sep="\t" )

df = df.groupby(["Date","Hour"]).sum().reset_index()
df2 = df2.groupby(["Date","Hour"]).sum().reset_index()
df["time"] =  df["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df["Hour"].apply(lambda x: timedelta(hours=x))
df2["time"] =  df2["Date"].apply(lambda x: datetime.strptime(x, '%m/%d/%Y %H:%M:%S %p')) + df2["Hour"].apply(lambda x: timedelta(hours=x))

df = df.set_index("time")
df = df.sort_index() 
df['total'] = df["avg_h"] + df["avg_l"]   
df2['total'] = df2["avg_h"] + df2["avg_l"]   

plt.plot(df["total"])
df2 = df2.set_index("time")
df2 = df2.sort_index()    
plt.plot(df2["total"])
plt.ylim(0,700000)  
locs, labels = plt.xticks()
plt.ylabel("Running Containers")
plt.setp(labels, rotation=45)
   